#version 330
uniform sampler2D videoTexture;
out vec4 FragColour;
in vec2 out_uvs;

uniform int stepsA;
uniform int stepsB;
uniform float strideA;
uniform float strideB;

float getWeight(float x)
{
    //return exp(-0.5*(x*x)/(0.5)); // magic number is sigma squared
    return exp(-0.5*(x*x)/0.06);
}
                             
// blur W
void main(void)
{
    ///*
    int STEPS = stepsA;
    vec4 totalA = vec4(0.0);
    vec4 totalWeight = vec4(0.0);
    
    // blurA
    for(int i = -STEPS; i <= STEPS; i++)
    {
        float weight = getWeight(float(i) / float(STEPS));
        totalA += vec4(weight) * texture(videoTexture, out_uvs.xy + vec2(float(i) * strideA, 0.0));
        totalWeight += vec4(weight);
    }
    
    totalA /= totalWeight;
    
    // blurB, reset vars
    vec4 totalB = vec4(0.0);
    STEPS = stepsB;
    totalWeight = vec4(0.0);
    
    for(int i = -STEPS; i <= STEPS; i++)
    {
        float weight = getWeight(float(i) / float(STEPS));
        totalB += vec4(weight) * texture(videoTexture, out_uvs.xy + vec2(float(i) * strideB, 0.0));
        totalWeight += vec4(weight);
    }
    
    totalB /= totalWeight;
    
    FragColour.r = totalA.r; // red
    FragColour.g = totalA.g; // red's alpha in green
    FragColour.b = totalB.b; // blue
    FragColour.a = totalB.a; // blue's alpha in alpha
    
    // debug: this shader does nothing
    //FragColour = texture(videoTexture, out_uvs);
}
